$fn=64;

use <knurledFinishLib_v2.scad>
/* knurledFinish
 * Written by aubenc @ Thingiverse
 * This script is licensed under the Public Domain license.
 * http://www.thingiverse.com/thing:31122
 */
 
dia_finger=20; //in mm

ring_h=7;

inner_w=1;
outer_w=2;
gap_w=.7;
ridge_w=1.4;
click_r=ridge_w;

clicks=0;


chamferring(dia_finger,                   ridge_w, inner_w, ridge_w*2, 0,gap_w,0);

chamferring(dia_finger+inner_w*2+gap_w*2, ridge_w, outer_w, ridge_w, 1,gap_w,+ridge_w*4);


module chamferring(dia_finger, ridge_w, inner_w,outerchamfer,knurl_dp, gap_w, innerchamfer)
{
    module innercut()
    {
        //translate([0,0,-1])
        //    cylinder(d=dia_finger,h=ring_h+2);

        translate([0,0,-1+.01])
            cylinder(d=dia_finger+ridge_w*2,h=1.01);

        cylinder(d1=dia_finger+ridge_w*2,d2=dia_finger+innerchamfer,h=ridge_w);
        
        translate([0,0,ridge_w-.01])
            cylinder(d=dia_finger+innerchamfer,h=ring_h-2*ridge_w+.02);
            
        translate([0,0,ring_h-ridge_w])
            cylinder(d1=dia_finger+innerchamfer,d2=dia_finger+ridge_w*2,h=ridge_w+.01);
            
    }

    difference()
    {
        union()
        {
            cylinder(d1=dia_finger+ridge_w*2+inner_w*2,d2=dia_finger+inner_w*2+outerchamfer*2,h=ridge_w);
            
            translate([0,0,ridge_w])
                cylinder(d=dia_finger+inner_w*2+2*outerchamfer,h=ring_h-2*ridge_w);
                
            translate([0,0,ring_h-ridge_w])
                cylinder(d1=dia_finger+inner_w*2+2*outerchamfer,d2=dia_finger+ridge_w*2+inner_w*2,h=ridge_w);
            
            if (knurl_dp>0)
            {
                knurl(k_cyl_hg= ring_h,	k_cyl_od = dia_finger+ridge_w*2+inner_w*2+knurl_dp,knurl_dp=knurl_dp);
            }
        
            
        }
        
        innercut();
        
        click_baseprint_continous=.2;
        
        if (knurl_dp==0 && clicks>0)
        {
            //color("red")
            for(j = [0 : 45 : 360])
            rotate([0,0,j])
            translate([(dia_finger+inner_w*2+2*outerchamfer)/2,0,+click_baseprint_continous])
                cylinder(r=click_r+gap_w,h=ring_h);
        }
        
        *translate([0,0,ring_h])
            cube([dia_finger+10,dia_finger+10,ring_h],center=true);
        *cube([dia_finger+10,dia_finger+10,ring_h+1]);
    }

    if (knurl_dp>0 && clicks>0)
    {
        color("red")
        translate([(dia_finger+innerchamfer)/2,0,0])
            cylinder(r=click_r,h=ring_h);
    }
}